#ifndef __INPUT_HEADER_FILE
#define __INPUT_HEADER_FILE

enum
{
											PAD_LEFT,
											PAD_RIGHT,
											PAD_UP,
											PAD_DOWN,
											PAD_BUTTON1,
											PAD_BUTTON2,
											PAD_START,
											NO_OF_BUTTONS
};

#define JOYSTICK_RANGE						1000

#define MAX_JOYSTICKS						8
#define MAX_JOYSTICK_BUTTONS				32

typedef struct JOYSTICK_INFO
{
	LPDIRECTINPUTDEVICE7					pDevice;
	char									Name[MAX_PATH];
	BOOL									Acquired;
} JOYSTICK_INFO;

BOOL										InitInput(HWND, HINSTANCE);
void										TidyInput(void);
void										AcquireKeyboard(void);
void										UnacquireKeyboard(void);
void										UpdateKeyboard(void);
char										*ButtonToString(int, int);
int											GetKeyPressed(BOOL);
void										SetControlKey(int, int, int);
BOOL FAR PASCAL								EnumJoysticks(LPCDIDEVICEINSTANCE, LPVOID *);
void										AcquireJoystick(int);
void										UnacquireJoystick(int);
void										UpdateJoysticks(void);
BOOL										JoystickPresent(void);
int											GetJoystickButtonPressed(void);
BOOL										GetJoystickName(int, char *);
int											GetSelectedJoystick(int);
void										SetSelectedJoystick(int, int);
int											FindJoystick(int);
void										UpdateSpecialKeys(void);
void										UpdateRapidFire(unsigned int);

#endif