
#ifndef _SMS_H_
#define _SMS_H_

/* Country setting */
#define TYPE_OVERSEAS   (0)     /* Usually Europe / USA */
#define TYPE_DOMESTIC   (1)     /* Japan */

/* SMS context */
typedef struct
{
    byte dummy[0x2000];
    byte ram[0x2000];
    byte sram[0x8000];
    byte irq;
    byte fcr[4];
    byte paused;
    byte save;
    byte country;
    byte fm_enable;
    byte port_06;
    byte port_3F;
    byte port_F2;
}t_sms;

/* Global data */
extern t_sms sms;

/* Function prototypes */
void sms_frame(int skip_render);
void sms_init(void);
void sms_reset(void);
void gg_port_w(int port, int data);
void sms_port_w(int port, int data);
int gg_port_r(int port);
int sms_port_r(int port);
void sms_mapper_w(int address, int data);
int irq_callback(int param);
void sound_update(void);

#endif /* _SMS_H_ */
